diff --git a/digikam/editor-cm-connection.docbook b/digikam/editor-cm-connection.docbook
index f5b4a70..677fcf8 100644
--- a/digikam/editor-cm-connection.docbook
+++ b/digikam/editor-cm-connection.docbook
@@ -5,7 +5,7 @@
     </para>
 
     <para>
-        There are two commonly used Profile Connection Spaces - CIELAB and CIEXYZ (see <ulink url="http://en.wikipedia.org/wiki/Color_management">Color management</ulink>, section on color translation, then look up CIELAB and CIEXYZ on wikipedia).  Lcms uses the camera profile to translate the RGB values from the interpolated raw file, that is, the tiff produced by dcraw, into the appropriate Profile Connection Space (usually CIEXYZ - why CIEXYZ? I haven't taken the time to learn). A profile connection space is not itself a working space.  Rather a PCS is an absolute reference space used only for translating from one color space to another - think of a PCS as a Universal Translator for all the color profiles that an image might encounter in the course of its journey from camera raw file to final output:
+        There are two commonly used Profile Connection Spaces - CIELAB and CIEXYZ (see <ulink url="https://en.wikipedia.org/wiki/Color_management">Color management</ulink>, section on color translation, then look up CIELAB and CIEXYZ on wikipedia).  Lcms uses the camera profile to translate the RGB values from the interpolated raw file, that is, the tiff produced by dcraw, into the appropriate Profile Connection Space (usually CIEXYZ - why CIEXYZ? I haven't taken the time to learn). A profile connection space is not itself a working space.  Rather a PCS is an absolute reference space used only for translating from one color space to another - think of a PCS as a Universal Translator for all the color profiles that an image might encounter in the course of its journey from camera raw file to final output:
     </para>
 
     <orderedlist>
@@ -122,7 +122,7 @@
         </para> 
 
         <para>
-            Now, the next question is: which working space should I use? <ulink url="http://en.wikipedia.org/wiki/Color_management#Working_spaces">Wikipedia says: </ulink> <blockquote><para>Working spaces, such as sRGB or Adobe RGB, are color spaces that facilitate good results while editing. For instance, pixels with equal values of RGB should appear neutral. Using a large (gamut) working space will lead to posterization, while using a small working space will lead to clipping. This trade-off is a consideration for the critical image editor</para></blockquote>
+            Now, the next question is: which working space should I use? <ulink url="https://en.wikipedia.org/wiki/Color_management#Working_spaces">Wikipedia says: </ulink> <blockquote><para>Working spaces, such as sRGB or Adobe RGB, are color spaces that facilitate good results while editing. For instance, pixels with equal values of RGB should appear neutral. Using a large (gamut) working space will lead to posterization, while using a small working space will lead to clipping. This trade-off is a consideration for the critical image editor</para></blockquote>
         </para>
 
         <para>
@@ -166,7 +166,7 @@
         </para>
 
         <para>
-            Some people are trying to standardize on gamma 2.0.  sRGB and LStar-RGB are not gamma-based working spaces. Rather, sRGB uses a <ulink url="http://en.wikipedia.org/wiki/SRGB">hybrid gamma</ulink>, and LStar-RGB uses a luminosity-based tonal response curve instead of a gamma value - see <ulink url="http://www.colormanagement.org/en/workingspaces.html">here</ulink> for more information, and then google around for more in-depth information.
+            Some people are trying to standardize on gamma 2.0.  sRGB and LStar-RGB are not gamma-based working spaces. Rather, sRGB uses a <ulink url="https://en.wikipedia.org/wiki/SRGB">hybrid gamma</ulink>, and LStar-RGB uses a luminosity-based tonal response curve instead of a gamma value - see <ulink url="http://www.colormanagement.org/en/workingspaces.html">here</ulink> for more information, and then google around for more in-depth information.
         </para>
 
         <para>
@@ -267,7 +267,7 @@
             </para></listitem>
 
             <listitem><para>
-                <ulink url="http://en.wikipedia.org/wiki/CIELAB">CIELab</ulink>
+                <ulink url="https://en.wikipedia.org/wiki/Lab_color_space#CIELAB">CIELab</ulink>
             </para></listitem>
 
             <listitem><para>
diff --git a/digikam/editor-cm-monitor.docbook b/digikam/editor-cm-monitor.docbook
index e445daa..c5028f1 100644
--- a/digikam/editor-cm-monitor.docbook
+++ b/digikam/editor-cm-monitor.docbook
@@ -39,7 +39,7 @@
         <title>The meaning of "black point" and "brightness" seems pretty clear, but what does "gamma" mean?</title>
 
         <para>
-            See <ulink url="http://en.wikipedia.org/wiki/Gamma_correction">this Wikipedia article</ulink> for an overview of the role of gamma in monitors and photography; the links at the bottom of the article are all excellent sources of additional information. Wikipedia says "Gamma compression, also known as gamma encoding, is used to encode linear luminance or RGB values into video signals or digital video file values; gamma expansion is the inverse, or decoding, process ... Gamma encoding helps to map data (both analog and digital) into a more perceptually uniform domain."  Yeah, I know, clear as mud. Read the Wikipedia article and study the pictures. Eventually it will sink in. If you wade very deeply into image editing and color management, eventually you will need to make decisions about what gamma (or other encoding/decoding function) you want to use when you calibrate your monitor, profile your digital camera, and choose a working color space. When in doubt (for those of you who just want to know which button to push!), gamma=2.2 is a widely-used value, both for monitor calibration and working color spaces.
+            See <ulink url="https://en.wikipedia.org/wiki/Gamma_correction">this Wikipedia article</ulink> for an overview of the role of gamma in monitors and photography; the links at the bottom of the article are all excellent sources of additional information. Wikipedia says "Gamma compression, also known as gamma encoding, is used to encode linear luminance or RGB values into video signals or digital video file values; gamma expansion is the inverse, or decoding, process ... Gamma encoding helps to map data (both analog and digital) into a more perceptually uniform domain."  Yeah, I know, clear as mud. Read the Wikipedia article and study the pictures. Eventually it will sink in. If you wade very deeply into image editing and color management, eventually you will need to make decisions about what gamma (or other encoding/decoding function) you want to use when you calibrate your monitor, profile your digital camera, and choose a working color space. When in doubt (for those of you who just want to know which button to push!), gamma=2.2 is a widely-used value, both for monitor calibration and working color spaces.
         </para>
 
     </sect3>
diff --git a/digikam/editor-cm-pcs.docbook b/digikam/editor-cm-pcs.docbook
index dc08a71..633166e 100644
--- a/digikam/editor-cm-pcs.docbook
+++ b/digikam/editor-cm-pcs.docbook
@@ -36,11 +36,11 @@
         </para>
 
         <para>
-            After extensive testing, the ICC produced the CIE-XYZ color space which mathematically describes and models all the colors visible to an ideal human observer ("ideal" in the sense of modeling the tested responses of lots of individual humans). This color space is NOT a color profile in the normal sense of the word. Rather it provides an absolute "Profile Connecting Space" (PCS) for translating color RGB values from one color space to another. (See <ulink url="http://en.wikipedia.org/wiki/Tristimulus#Tristimulus_values">here</ulink> and <ulink url="http://en.wikipedia.org/wiki/Color_vision">here</ulink>.)
+            After extensive testing, the ICC produced the CIE-XYZ color space which mathematically describes and models all the colors visible to an ideal human observer ("ideal" in the sense of modeling the tested responses of lots of individual humans). This color space is NOT a color profile in the normal sense of the word. Rather it provides an absolute "Profile Connecting Space" (PCS) for translating color RGB values from one color space to another. (See <ulink url="https://en.wikipedia.org/wiki/CIE_1931_color_space#Tristimulus_values">here</ulink> and <ulink url="https://en.wikipedia.org/wiki/Color_vision">here</ulink>.)
         </para>
 
         <para>
-            CIE-XYZ is not the only PCS. Another commonly used PCS is CIE-Lab, which is mathematically derived from the CIE-XYZ space. CIE-Lab is intended to be "perceptually uniform", meaning "a change of the same amount in a color value should produce a change of about the same visual importance" (cited from <ulink url="http://en.wikipedia.org/wiki/Lab_color_space">Wikipedia article</ulink>). Wikipedia says "The three coordinates of CIELAB represent the lightness of the color (L* = 0 yields black and L* = 100 indicates diffuse white; specular white may be higher), its position between red/magenta and green (a*, negative values indicate green while positive values indicate magenta) and its position between yellow and blue (b*, negative values indicate blue and positive values indicate yellow)"  (cited from <ulink url="http://en.wikipedia.org/wiki/Lab_color_space">Wikipedia article</ulink>).
+            CIE-XYZ is not the only PCS. Another commonly used PCS is CIE-Lab, which is mathematically derived from the CIE-XYZ space. CIE-Lab is intended to be "perceptually uniform", meaning "a change of the same amount in a color value should produce a change of about the same visual importance" (cited from <ulink url="https://en.wikipedia.org/wiki/Lab_color_space">Wikipedia article</ulink>). Wikipedia says "The three coordinates of CIELAB represent the lightness of the color (L* = 0 yields black and L* = 100 indicates diffuse white; specular white may be higher), its position between red/magenta and green (a*, negative values indicate green while positive values indicate magenta) and its position between yellow and blue (b*, negative values indicate blue and positive values indicate yellow)"  (cited from <ulink url="https://en.wikipedia.org/wiki/Lab_color_space">Wikipedia article</ulink>).
         </para>
 
         <para>
diff --git a/digikam/editor-cm-rawfile.docbook b/digikam/editor-cm-rawfile.docbook
index f43d464..2bdddf2 100644
--- a/digikam/editor-cm-rawfile.docbook
+++ b/digikam/editor-cm-rawfile.docbook
@@ -125,7 +125,7 @@
         </title>
 
         <para>
-            The whole point of interpolation using demosaicing algorithms such as dcraw's default AHD is to guess what color and intensity of light actually fell on any given pixel by interpolating information gathered from that single pixel plus its neighboring pixels (see <ulink url="http://en.wikipedia.org/wiki/Demosaic">Wikipedia article</ulink>). Every raw processing program makes additional assumptions such as "when is it signal and when is it background noise?",  "at what point has the sensor well reached full saturation?", and so forth. The resulting output of all these algorithms and assumptions that raw processing software makes is a trio of RGB values for each pixel in the image. Given the same raw file, different raw processors will output different RGB values.
+            The whole point of interpolation using demosaicing algorithms such as dcraw's default AHD is to guess what color and intensity of light actually fell on any given pixel by interpolating information gathered from that single pixel plus its neighboring pixels (see <ulink url="https://en.wikipedia.org/wiki/Demosaicing">Wikipedia article</ulink>). Every raw processing program makes additional assumptions such as "when is it signal and when is it background noise?",  "at what point has the sensor well reached full saturation?", and so forth. The resulting output of all these algorithms and assumptions that raw processing software makes is a trio of RGB values for each pixel in the image. Given the same raw file, different raw processors will output different RGB values.
         </para>
 
     </sect3>
diff --git a/digikam/editor-cm-wkspace.docbook b/digikam/editor-cm-wkspace.docbook
index 99ee9b7..44e088c 100644
--- a/digikam/editor-cm-wkspace.docbook
+++ b/digikam/editor-cm-wkspace.docbook
@@ -62,11 +62,11 @@
         </para>
 
         <para>
-            sRGB uses a transfer function close to that of a CRT (and thus not necessarily relevant to image editing or to display on an LCD). As Wikipedia notes, "Unlike most other RGB color spaces the sRGB gamma can not be expressed as a single numerical value. The overall gamma is approximately 2.2, consisting of a linear (gamma 1.0) section near black, and a non-linear section elsewhere involving a 2.4 exponent and a gamma (slope of log output versus log input) changing from 1.0 through about 2.3" (cited from <ulink url="http://en.wikipedia.org/wiki/SRGB">this page</ulink>), which makes for some complicated math during image processing.
+            sRGB uses a transfer function close to that of a CRT (and thus not necessarily relevant to image editing or to display on an LCD). As Wikipedia notes, "Unlike most other RGB color spaces the sRGB gamma can not be expressed as a single numerical value. The overall gamma is approximately 2.2, consisting of a linear (gamma 1.0) section near black, and a non-linear section elsewhere involving a 2.4 exponent and a gamma (slope of log output versus log input) changing from 1.0 through about 2.3" (cited from <ulink url="https://en.wikipedia.org/wiki/SRGB">this page</ulink>), which makes for some complicated math during image processing.
         </para>
 
         <para>
-            L*-RGB uses as its transfer function the same perceptually uniform transfer function as the CIELab color space. "When storing colors in limited precision values" using a perceptually uniform transfer function "can improve the reproduction of tones" (cited from <ulink url="http://en.wikipedia.org/wiki/Lab_color_space">this page</ulink>).
+            L*-RGB uses as its transfer function the same perceptually uniform transfer function as the CIELab color space. "When storing colors in limited precision values" using a perceptually uniform transfer function "can improve the reproduction of tones" (cited from <ulink url="https://en.wikipedia.org/wiki/Lab_color_space">this page</ulink>).
         </para>
 
         <para>
diff --git a/digikam/intro-imageformats.docbook b/digikam/intro-imageformats.docbook
index 08a4445..ece8782 100644
--- a/digikam/intro-imageformats.docbook
+++ b/digikam/intro-imageformats.docbook
@@ -15,7 +15,7 @@
         </para>
 
         <para>
-            Almost all digital cameras store photographs in one of two formats: JPEG or TIFF. Many cameras enable you to select which of these formats to use. A full description of these formats can be found at the <ulink url="http://en.wikipedia.org/wiki/Graphics_file_format">Wikipedia</ulink>. &digikam; supports both of these formats.
+            Almost all digital cameras store photographs in one of two formats: JPEG or TIFF. Many cameras enable you to select which of these formats to use. A full description of these formats can be found at the <ulink url="https://en.wikipedia.org/wiki/Image_file_formats">Wikipedia</ulink>. &digikam; supports both of these formats.
         </para>
 
     </sect2>
@@ -79,11 +79,11 @@
         </para>
 
         <para>
-            If you want to learn more about RAW image format visit the very helpful guides<ulink url="http://en.wikipedia.org/wiki/RAW_image_format"> Wikipedia,</ulink> <ulink url="http://www.luminous-landscape.com/tutorials/understanding-series/u-raw-files.shtml"> The Luminous Landscape,</ulink> and <ulink url="http://www.cambridgeincolour.com/tutorials/RAW-file-format.htm"> Cambridge in Colour</ulink>. You can convert RAW format images into JPEG, PNG, or TIFF in &digikam; using the <link linkend="raw-workflow">Image Editor</link>.
+            If you want to learn more about RAW image format visit the very helpful guides<ulink url="https://en.wikipedia.org/wiki/Raw_image_format"> Wikipedia,</ulink> <ulink url="http://www.luminous-landscape.com/tutorials/understanding-series/u-raw-files.shtml"> The Luminous Landscape,</ulink> and <ulink url="http://www.cambridgeincolour.com/tutorials/RAW-file-format.htm"> Cambridge in Colour</ulink>. You can convert RAW format images into JPEG, PNG, or TIFF in &digikam; using the <link linkend="raw-workflow">Image Editor</link>.
         </para>
 
         <para>
-            &digikam; supports RAW image loading only, relying on the <ulink url="http://www.libraw.org">Libraw library</ulink> which is included in &digikam; core and supports over 800 RAW file formats. All supported cameras are listed at the bottom of <ulink url="http://www.cybercom.net/~dcoffin/dcraw"> Dave Coffin's</ulink> web page. The table below shows a short list of camera RAW files supported by &digikam;:
+            &digikam; supports RAW image loading only, relying on the <ulink url="https://www.libraw.org">Libraw library</ulink> which is included in &digikam; core and supports over 800 RAW file formats. All supported cameras are listed at the bottom of <ulink url="http://www.cybercom.net/~dcoffin/dcraw"> Dave Coffin's</ulink> web page. The table below shows a short list of camera RAW files supported by &digikam;:
 
             <informaltable><tgroup cols="2">
 
diff --git a/digikam/using-bqm.docbook b/digikam/using-bqm.docbook
index a38c55c..aa8ea5c 100644
--- a/digikam/using-bqm.docbook
+++ b/digikam/using-bqm.docbook
@@ -53,7 +53,7 @@
             </para>
 
             <para>
-            A <guilabel>Four color RGBG</guilabel> conversion can be selected to use contrast
+            A <guilabel>Interpolate RGB as four colors</guilabel> conversion can be selected to use contrast
             information. (If your camera works in RGB mode, the RGBG setting has no effect).
             </para>
 
diff --git a/digikam/using-camera-processing.docbook b/digikam/using-camera-processing.docbook
index cb638a3..925b679 100644
--- a/digikam/using-camera-processing.docbook
+++ b/digikam/using-camera-processing.docbook
@@ -37,7 +37,7 @@
         </para>
 
         <para>
-            The calendar is active only if <quote>Fixed Date</quote> is selected from the <guilabel>Source:</guilabel> drop down field. This way you can add the same date and time information to the filenames of all imported images or videos. If <quote>Image</quote> is selected instead &digikam; will use the time information from the metadata of the image files. With the <guilabel>Format:</guilabel> drop down field you can choose from several standard date/time formats and a custom format. For the latter choose <guilabel>Custom</guilabel> in <guilabel>Format:</guilabel> drop-down list and fill in for example "dd.MM.yyyy hh:mm:ss". For more information, read <ulink url="http://qt-project.org/doc/qt-5.0/qtcore/qdatetime.html#toString">QDateTime</ulink> class reference.
+            The calendar is active only if <quote>Fixed Date</quote> is selected from the <guilabel>Source:</guilabel> drop down field. This way you can add the same date and time information to the filenames of all imported images or videos. If <quote>Image</quote> is selected instead &digikam; will use the time information from the metadata of the image files. With the <guilabel>Format:</guilabel> drop down field you can choose from several standard date/time formats and a custom format. For the latter choose <guilabel>Custom</guilabel> in <guilabel>Format:</guilabel> drop-down list and fill in for example "dd.MM.yyyy hh:mm:ss". For more information, read <ulink url="http://doc.qt.io/qt-5/qdatetime.html#toString">QDateTime</ulink> class reference.
         </para>
 
         <para>
diff --git a/digikam/using-dam-build.docbook b/digikam/using-dam-build.docbook
index 0813dba..acd919e 100644
--- a/digikam/using-dam-build.docbook
+++ b/digikam/using-dam-build.docbook
@@ -78,7 +78,7 @@
         </para>
 
         <para>
-            I also recommend to switch-on the 'save metadata' options in the &digikam; settings page for metadata. This will ensure that EXIF and IPTC data is written into the file. If you forgot to do that you can always catch up by copying the metadata in the database to the files in one go (from the album menu).
+            I also recommend to switch-on the 'save metadata' options in the &digikam; settings page for metadata. This will ensure that EXIF and IPTC data is written into the file. If you forgot to do that you can always catch up by copying the metadata in the database to the files in one go (from the Album menu).
         </para>
 
         <para>
diff --git a/digikam/using-dam-corruption.docbook b/digikam/using-dam-corruption.docbook
index d92aa6a..1024bbd 100644
--- a/digikam/using-dam-corruption.docbook
+++ b/digikam/using-dam-corruption.docbook
@@ -90,7 +90,7 @@
             </para>
 
             <para>
-                For damaged CDs and DVDs, there is an inexpensive program called <ulink url="http://www.isobuster.com/">IsoBuster</ulink> from which will do seeming miracles on CDs and DVDs. It runs on Windows and &Linux;; but not (yet) on Macs. Similarly, there are applications designed to get data from damaged floppies, hard drives, flash media such as camera memory and USB drives, and so forth.
+                For damaged CDs and DVDs, there is an inexpensive program called <ulink url="https://www.isobuster.com/">IsoBuster</ulink> from which will do seeming miracles on CDs and DVDs. It runs on Windows and &Linux;; but not (yet) on Macs. Similarly, there are applications designed to get data from damaged floppies, hard drives, flash media such as camera memory and USB drives, and so forth.
             </para>
 
             <para>
@@ -111,7 +111,7 @@
             <title>Hard disks (hard drives, HDD)</title>
 
             <para>
-                Disk manufacturers keep their statistics to themselves. A manufacturer guaranty buys you a new disk, but no data. Google for one has done a large scale study on HDD failure mechanisms: <ulink url="http://research.google.com/archive/disk_failures.pdf">Disk Failures study</ulink>
+                Disk manufacturers keep their statistics to themselves. A manufacturer guaranty buys you a new disk, but no data. Google for one has done a large scale study on HDD failure mechanisms: <ulink url="https://research.google.com/archive/disk_failures.pdf">Disk Failures study</ulink>
             </para>
 
             <para>
diff --git a/digikam/using-lighttable.docbook b/digikam/using-lighttable.docbook
index aed6444..5a58b17 100644
--- a/digikam/using-lighttable.docbook
+++ b/digikam/using-lighttable.docbook
@@ -20,11 +20,11 @@
 </para>
 
     <para>
-        From the thumbbar drag &amp; drop images to the left and right comparison pane below. A little arrow will indicate which copy is shown in which pane. If you choose <guilabel>Synchronize Preview</guilabel> from the toolbar, any zoom and panning in one window will be synchronously executed in the other pane, so that you can compare the same areas of two images.
+        From the thumbbar drag &amp; drop images to the left and right comparison pane below. A little arrow will indicate which copy is shown in which pane. If you choose <guilabel>Synchronize</guilabel> from the toolbar, any zoom and panning in one window will be synchronously executed in the other pane, so that you can compare the same areas of two images.
     </para>
 
     <para>
-        Another mode is better suited for quickly culling from a series of images. If you choose <guilabel>Navigate by Pair</guilabel> from the toolbar, the first two images will be automatically inserted into the comparison panes. Click on any thumbnail to make it the left side preview, the adjacent thumbnail to the right will be inserted into the right pane. That make it easy to sift through a series of similar images.
+        Another mode is better suited for quickly culling from a series of images. If you choose <guilabel>By Pair</guilabel> from the toolbar, the first two images will be automatically inserted into the comparison panes. Click on any thumbnail to make it the left side preview, the adjacent thumbnail to the right will be inserted into the right pane. That make it easy to sift through a series of similar images.
     </para>
 
     <para>
@@ -42,7 +42,7 @@
     </para>
 
     <para>
-        In the lower right corner of each pane there you find a built-in panning action (crossed arrows). Click on it and keep the &LMB; pressed to pan across the image (in synchronous mode both images will show the same viewing port).
+        In the lower right corner of each pane there you find a built-in panning action (crossed arrows). Click on it and keep the &LMB; pressed to pan across the image (in synchronous mode both images will show the same viewing point).
     </para>
 
     <para>
diff --git a/digikam/using-setup-database.docbook b/digikam/using-setup-database.docbook
index 13d4b4a..1b1af06 100644
--- a/digikam/using-setup-database.docbook
+++ b/digikam/using-setup-database.docbook
@@ -237,7 +237,7 @@
         </para>
 
         <para>
-            To migrate to another database, go to <menuchoice><guimenu>Settings</guimenu> <guimenuitem>Migration</guimenuitem></menuchoice>. A dialog box appears:
+            To migrate to another database, go to <menuchoice><guimenu>Settings</guimenu> <guimenuitem>Database Migration...</guimenuitem></menuchoice>. A dialog box appears:
         </para>
 
         <para>
diff --git a/digikam/using-setup-editor-raw.docbook b/digikam/using-setup-editor-raw.docbook
index 20a607b..ac1a276 100644
--- a/digikam/using-setup-editor-raw.docbook
+++ b/digikam/using-setup-editor-raw.docbook
@@ -52,7 +52,7 @@
     </para>
 
         <para>
-            A <ulink url="http://en.wikipedia.org/wiki/Demosaicing">demosaicing</ulink> algorithm is a digital image process used to interpolate a complete image from the partial raw data received from the color-filtered image sensor internal to many digital cameras in form of a matrix of colored pixels. Also known as CFA interpolation or color reconstruction.
+            A <ulink url="https://en.wikipedia.org/wiki/Demosaicing">demosaicing</ulink> algorithm is a digital image process used to interpolate a complete image from the partial raw data received from the color-filtered image sensor internal to many digital cameras in form of a matrix of colored pixels. Also known as CFA interpolation or color reconstruction.
         </para>
 
         <para>
diff --git a/digikam/using-setup-editor-save.docbook b/digikam/using-setup-editor-save.docbook
index a57b14f..1a458ee 100644
--- a/digikam/using-setup-editor-save.docbook
+++ b/digikam/using-setup-editor-save.docbook
@@ -6,7 +6,7 @@
     </para>
 
     <para>
-        Chroma subsampling is the practice of encoding images by implementing more resolution for luminance information than for color information. Please read <ulink url="http://en.wikipedia.org/wiki/Chroma_subsampling">this</ulink> Wikipedia article for a full explanation.
+        Chroma subsampling is the practice of encoding images by implementing more resolution for luminance information than for color information. Please read <ulink url="https://en.wikipedia.org/wiki/Chroma_subsampling">this</ulink> Wikipedia article for a full explanation.
     </para>
 
     <para>
diff --git a/digikam/using-setup-views.docbook b/digikam/using-setup-views.docbook
index f81965f..a83dd26 100644
--- a/digikam/using-setup-views.docbook
+++ b/digikam/using-setup-views.docbook
@@ -109,7 +109,7 @@
         </para>
 
         <para>
-            The option <guilabel>Embedded view zoomed to the original image size</guilabel> is related to the first option. It will zoom the embedded view to the original image size which can lead to a reduced quality of the preview depending on the parameters mentioned above in the description of the first option.
+            The option <guilabel>Preview is zoomed to the original image size </guilabel> is related to the first option. It will zoom the embedded view to the original image size which can lead to a reduced quality of the preview depending on the parameters mentioned above in the description of the first option.
         </para>
 
         <para>