From 3168992ddb7c76e41808e0a0f61c077268e258a7 Mon Sep 17 00:00:00 2001
From: Dmitri Popov <dmpop@linux.com>
Date: Sun, 21 Jan 2018 14:27:11 +0100
Subject: [PATCH] Update digiKam Recipes info

---
 content/recipes_book.md               |   4 ++--
 static/img/digikam-recipes-reader.png | Bin 0 -> 189389 bytes
 static/img/digikam-recipes.png        | Bin 75468 -> 42732 bytes
 3 files changed, 2 insertions(+), 2 deletions(-)
 create mode 100644 static/img/digikam-recipes-reader.png

diff --git a/content/recipes_book.md b/content/recipes_book.md
index 8c6e5f2..4e8116a 100644
--- a/content/recipes_book.md
+++ b/content/recipes_book.md
@@ -7,7 +7,7 @@ category: "documentation"
 aliases: "digikamrecipes"
 ---
 
-digiKam is an immensely powerful photo management application, and mastering it requires time and effort. This book can help you to learn the ropes in the most efficient manner. Instead of explaining every digiKam’s feature, the book offers a collection of techniques that can help you to get the most out of this versatile tool.
+digiKam is an immensely powerful photo management application, and mastering it requires time and effort. This book can help you to learn the ropes in the most efficient manner. Instead of going through each and every menu item and feature, the book provides a task-oriented description of digiKam's functionality that can help you to get the most out of this versatile tool. The book offers easy-to-follow instructions on how to organize and manage photos, process RAW files, edit images and apply various effects, export and publish photos, and much more.
 
 <div class="row columns text-center">
 	<h3>Buy now!</h3>
@@ -34,7 +34,7 @@ digiKam is an immensely powerful photo management application, and mastering it
 	</div>
 </div>
 
-![digiKam Recipes in Cool Reader](https://scribblesandsnaps.files.wordpress.com/2015/03/digikamrecipes-page.png "digikamrecipescoolreader")
+![digiKam Recipes Reader](/img/digikam-recipes-reader.png)
 
 Five facts about the digiKam Recipes ebook:
 
diff --git a/static/img/digikam-recipes-reader.png b/static/img/digikam-recipes-reader.png
new file mode 100644
index 0000000000000000000000000000000000000000..cda942a2952bba275687b506d46466a2b9210547
GIT binary patch
diff --git a/static/img/digikam-recipes.png b/static/img/digikam-recipes.png
index 6599045799868a5f840e1c1a657ca6346965b1df..931aa8c868fa8c441e5b195623e95697ce15cc2c 100644
GIT binary patch
-- 
2.13.6